package com.zksy.web.controller.basicData;

import com.zksy.common.core.controller.BaseController;
import com.zksy.basicData.domain.XcrSoftWorks;
import com.zksy.basicData.service.IXcrSoftWorksService;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.basicData.utils.DowntemplateUtil;
import com.zksy.common.utils.SearchUtil;
import com.zksy.common.annotation.Log;
import com.zksy.common.enums.BusinessType;
import com.zksy.common.utils.poi.ExcelUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.multipart.MultipartFile;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * 软件著作权Controller
 *
 * @author nahida
 * @date 2024-12-12
 */
@RestController
@RequestMapping("/basicData/xcrSoftWorks")
@Api(tags = "软件著作权", description = "软件著作权desc")
public class XcrSoftWorksController extends BaseController{

    @Autowired
    private IXcrSoftWorksService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "软件著作权搜索getById")
    @PreAuthorize("@ss.hasPermi('basicData:xcrSoftWorks:list')")
    public XcrSoftWorks getById(@PathVariable String borrowId) {
        return service.getById(borrowId);
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "软件著作权分页")
    @PreAuthorize("@ss.hasPermi('basicData:xcrSoftWorks:list')")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "软件著作权查询所有")
    @PreAuthorize("@ss.hasPermi('basicData:xcrSoftWorks:list')")
    public List<XcrSoftWorks> getList(String conditionJson) throws Exception {
        return service.list(SearchUtil.parseWhereSql(conditionJson));
    }

    /**
     * 新增软件著作权
     */
    @PostMapping("/save")
    @ApiOperation(value = "软件著作权新增")
    @Log(title = "新增软件著作权", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody XcrSoftWorks xcrSoftWorks) {
        return service.save(xcrSoftWorks);
    }

    /**
     * 修改软件著作权
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "软件著作权修改")
    @Log(title = "修改软件著作权", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody XcrSoftWorks xcrSoftWorks) {
        return service.updateById(xcrSoftWorks);
    }


    @Log(title = "软件著作权", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除软件著作权", notes = "删除软件著作权")
    @PreAuthorize("@ss.hasPermi('basicData:xcrSoftWorks:delete')")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    /**
     * 导出软件著作权列表
     */
    @PreAuthorize("@ss.hasPermi('basicData:xcrSoftWorks:export')")
    @Log(title = "软件著作权", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response,String conditionJson) throws Exception
    {
        List<XcrSoftWorks> list = service.list(SearchUtil.parseWhereSql(conditionJson));
        ExcelUtil<XcrSoftWorks> util = new ExcelUtil<XcrSoftWorks>(XcrSoftWorks.class);
        util.exportExcel(response, list, "软件著作权数据");
    }
    /**
     * 导入软件著作权列表
     */
    @ApiOperation(value = "软件著作权导入")
    @Log(title = "软件著作权管理", businessType = BusinessType.IMPORT)
    @PreAuthorize("@ss.hasPermi('basicData:xcrSoftWorks:import')")
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file) throws Exception
    {
        ExcelUtil<XcrSoftWorks> util = new ExcelUtil<XcrSoftWorks>(XcrSoftWorks.class);
        List<XcrSoftWorks> list = util.importExcel(file.getInputStream());
        return toAjax(service.saveBatch(list));
    }

    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException, IOException {
        DowntemplateUtil.downloadTemplate(response,"软件著作权模板");
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除全表", notes = "清除全表")
    @PreAuthorize("@ss.hasPermi('basicData:xcrSoftWorks:delete')")
    @Log(title = "软件著作权清除全表", businessType = BusinessType.DELETE)
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }
}